#include <bits/stdc++.h>

typedef long long int ll;
typedef long double ld;

#define fori(i, n) for(ll i = 0; i < (n); ++i)
#define forI(i, n) for(ll i = 1; i <= (n); ++i)

#define pll pair<ll, ll>
#define f first
#define s second


ll n, m;

using namespace std;

ll mtx[10][10];

bool rec(ll x, ll y){
    if(y == m){
        ++x;
        y = 0;
        if(x == n){
            fori(x1, n - 1){
                fori(y1, m - 1){
                    for(ll x2 = x1 + 1; x2 < n; ++x2){
                        for(ll y2 = y1 + 1; y2 < m; ++y2){
                            ll sum = mtx[x1][y1] + mtx[x1][y2] + mtx[x2][y1] + mtx[x2][y2];
                            if(sum == 0 || sum == 4) return false;
                        }
                    }
                }
            }
            return true;
        }
    }
    mtx[x][y] = 0;
    if(rec(x, y + 1)) return true;
    mtx[x][y] = 1;
    return rec(x, y + 1);
}

bool rec3(ll x, ll y){
    if(y == m){
        ++x;
        y = 0;
        if(x == n){
            return true;
        }
    }
    mtx[x][y] = 0;
    bool in = true;
    fori(x1, x){
        fori(y1, y){
            if(mtx[x1][y] == 0 && mtx[x1][y1] == 0 && mtx[x][y1] == 0){
                in = false;
                break;
            }
        }
    }
    if(in && rec(x, y + 1)) return true;

    mtx[x][y] = 1;
    in = true;
    fori(x1, x){
        fori(y1, y){
            if(mtx[x1][y] == 1 && mtx[x1][y1] == 1 && mtx[x][y1] == 1){
                in = false;
                break;
            }
        }
    }
    if(in && rec(x, y + 1)) return true;

    mtx[x][y] = 2;
    in = true;
    fori(x1, x){
        fori(y1, y){
            if(mtx[x1][y] == 2 && mtx[x1][y1] == 2 && mtx[x][y1] == 2){
                in = false;
                break;
            }
        }
    }
    return in && rec(x, y + 1);
}

void solve(){
    //ll ban = 9;
    /*
    for(n = 3; n <= 8; ++n){
        for(m = n; m < ban; ++m){
            if(!rec(0, 0)){
                ban = m;
                //cout << n << ' ' << m << " - fail" << endl << endl;
            }else{
                cout << n << ' ' << m << " solution: " << endl;
                fori(i, n){
                    fori(j, m){
                        cout << mtx[i][j] + 1 << " ";
                    }
                    cout << endl;
                }
                cout << endl;
            }
        }
    }*/

    ll colors;
    cin >> n >> m >> colors;
    if(colors == 2){
        rec(0, 0);
        fori(i, n){
            fori(j, m){
                cout << mtx[i][j] + 1 << " ";
            }
            cout << endl;
        }
        cout << endl;
        return;
    }else{
        rec3(0, 0);
        fori(i, n){
            fori(j, m){
                cout << mtx[i][j] + 1 << " ";
            }
            cout << endl;
        }
        cout << endl;
        return;
    }
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    solve();
}