#include <bits/stdc++.h>

typedef long long int ll;
typedef long double ld;

#define fori(i, n) for(ll i = 0; i < (n); ++i)
#define forI(i, n) for(ll i = 1; i <= (n); ++i)

#define pll pair<ll, ll>
#define f first
#define s second


ll n, m;

using namespace std;

ll mtx[10][10];


bool ok() {
    fori(x1, n - 1) {
        fori(y1, m - 1) {
            ll clr = mtx[x1][y1];
            for (ll x2 = x1 + 1; x2 < n; ++x2) {
                for (ll y2 = y1 + 1; y2 < m; ++y2) {
                    if (mtx[x1][y2] == clr && mtx[x2][y1] == clr && mtx[x2][y2] == clr)
                        return false;
                }
            }
        }
    }
    return true;
}

bool rec(ll x, ll y) {
    if (y == m) {
        ++x;
        y = 0;
        if (x == n) {
            return ok();
        }
    }
    mtx[x][y] = 0;
    if (rec(x, y + 1)) return true;
    mtx[x][y] = 1;
    return rec(x, y + 1);
}

bool rec3(ll x, ll y) {
    if (y == m) {
        ++x;
        y = 0;
        if (x == n) {
            return true;
        }
    }
    mtx[x][y] = 0;
    bool in = true;
    fori(x1, x) {
        fori(y1, y) {
            if (mtx[x1][y] == 0 && mtx[x1][y1] == 0 && mtx[x][y1] == 0) {
                in = false;
                break;
            }
        }
    }
    if (in && rec3(x, y + 1)) return true;

    mtx[x][y] = 1;
    in = true;
    fori(x1, x) {
        fori(y1, y) {
            if (mtx[x1][y] == 1 && mtx[x1][y1] == 1 && mtx[x][y1] == 1) {
                in = false;
                break;
            }
        }
    }
    if (in && rec3(x, y + 1)) return true;

    mtx[x][y] = 2;
    in = true;
    fori(x1, x) {
        fori(y1, y) {
            if (mtx[x1][y] == 2 && mtx[x1][y1] == 2 && mtx[x][y1] == 2) {
                in = false;
                break;
            }
        }
    }
    return in && rec3(x, y + 1);
}

void solve2(ll x, ll y) {
    rec(0, 0);
    fori(i, n) {
        fori(j, m) {
            cout << mtx[i][j] + 1 << " ";
        }
        cout << endl;
    }
    cout << endl;
}

vector<pair<pll, vector<vector<ll>>>> preprocess = {
        {
                {4, 10},
                {
                        {1, 1, 1, 1, 1, 1, 1, 1, 1, 2},
                        {1, 2, 2, 2, 2, 2, 3, 3, 3, 1},
                        {2, 1, 2, 3, 3, 3, 2, 2, 3, 1},
                        {3, 3, 3, 1, 2, 3, 2, 3, 2, 1}
                },
        },
        {
                {5, 9},
                {
                        {1, 1, 1, 1, 1, 1, 1, 1, 2},
                        {1, 2, 2, 2, 2, 3, 3, 3, 1},
                        {1, 2, 3, 3, 3, 2, 2, 3, 2},
                        {2, 3, 1, 2, 3, 2, 3, 2, 1},
                        {3, 3, 1, 3, 2, 3, 2, 2, 3}
                }
        },
        {
                {5, 10},
                {
                        {1, 1, 1, 2, 2, 2, 2, 2, 1, 3},
                        {1, 2, 2, 2, 1, 3, 3, 3, 3, 1},
                        {2, 1, 3, 3, 3, 1, 1, 1, 3, 1},
                        {2, 3, 1, 1, 3, 1, 2, 3, 2, 2},
                        {3, 3, 2, 3, 1, 2, 3, 1, 1, 2}
                }
        },
        {
                {6, 7},
                {
                        {1, 1, 1, 1, 1, 1, 1},
                        {1, 2, 2, 2, 3, 3, 3},
                        {1, 2, 3, 3, 2, 2, 3},
                        {2, 3, 1, 3, 2, 3, 2},
                        {2, 3, 3, 2, 3, 2, 1},
                        {3, 1, 2, 3, 3, 2, 2}
                }
        },
        {
                {7, 7},
                {
                        {1, 1, 1, 1, 1, 1, 1},
                        {1, 2, 2, 2, 3, 3, 3},
                        {1, 2, 3, 3, 2, 2, 3},
                        {2, 3, 2, 3, 2, 3, 1},
                        {2, 3, 3, 2, 3, 2, 1},
                        {3, 1, 2, 3, 3, 2, 2},
                        {3, 1, 3, 2, 2, 3, 2}
                }
        },
        {
                {6, 8},
                {
                        {1, 1, 1, 1, 1, 1, 1, 2},
                        {1, 2, 2, 2, 3, 3, 3, 1},
                        {1, 2, 3, 3, 2, 2, 3, 2},
                        {2, 3, 1, 3, 2, 3, 2, 1},
                        {2, 3, 3, 2, 3, 2, 1, 1},
                        {3, 1, 2, 3, 3, 2, 2, 1}
                }
        },
        {
            {6, 9},
            {
                    {1, 1, 1, 2, 2, 2, 3, 3, 3},
                    {3, 3, 3, 1, 1, 1, 2, 2, 2},
                    {2, 2, 2, 3, 3, 3, 1, 1, 1},
                    {1, 2, 3, 1, 2, 3, 1, 2, 3},
                    {3, 1, 2, 3, 1, 2, 3, 1, 2},
                    {2, 3, 1, 2, 3, 1, 2, 3, 1}
                }
        },
        {
                {8, 8},
                {
                        {1, 1, 1, 1, 1, 1, 1, 2},
                        {1, 2, 2, 2, 3, 3, 3, 1},
                        {2, 2, 3, 3, 1, 2, 3, 1},
                        {2, 3, 2, 3, 2, 3, 1, 1},
                        {2, 3, 3, 2, 3, 1, 2, 1},
                        {3, 1, 2, 3, 3, 2, 2, 1},
                        {3, 2, 3, 1, 2, 3, 2, 1},
                        {3, 3, 1, 2, 2, 2, 3, 1}
                }
        },
        {
                {6, 10},
                {
                        {1, 1, 1, 2, 2, 2, 3, 3, 3, 2},
                        {3, 3, 3, 1, 1, 1, 2, 2, 2, 2},
                        {2, 2, 2, 3, 3, 3, 1, 1, 1, 2},
                        {1, 2, 3, 1, 2, 3, 1, 2, 3, 1},
                        {3, 1, 2, 3, 1, 2, 3, 1, 2, 1},
                        {2, 3, 1, 2, 3, 1, 2, 3, 1, 1}
                }
        }

};

void solve() {
    //ll ban = 9;
    /*
    for(n = 3; n <= 8; ++n){
        for(m = n; m < ban; ++m){
            if(!rec(0, 0)){
                ban = m;
                //cout << n << ' ' << m << " - fail" << endl << endl;
            }else{
                cout << n << ' ' << m << " solution: " << endl;
                fori(i, n){
                    fori(j, m){
                        cout << mtx[i][j] + 1 << " ";
                    }
                    cout << endl;
                }
                cout << endl;
            }
        }
    }*/

    ll colors;
    cin >> n >> m >> colors;


    if (colors == 2) {
        solve2(n, m);
        return;
    } else {
        ll nn = min(n, m);
        ll mm = max(n, m);
        if (nn == 2 || (nn <= 4 && mm <= 6)) {
            solve2(n, m);
            return;
        }

        bool zapis = 1;
        if (zapis) {
            vector<vector<ll>> ans(n, vector<ll>(m));
            fori(i, n) fori(j, m) cin >> ans[i][j];
            fori(i, n) fori(j, m) mtx[i][j] = ans[i][j];
            if (ok()) {
                cout << "ok" << endl;
                cout << "{\n";
                cout << "\t{" << n << ", " << m << "},\n";
                cout << "\t{" << endl;
                fori(i, n) {
                    cout << "\t\t{";
                    fori(j, m) {
                        cout << mtx[i][j];
                        if (j != m - 1) cout << ", ";
                    }
                    cout << "}";
                    if (i != n - 1) cout << ",";
                    cout << endl;
                }
                cout << "\t}\n}" << endl;
            } else {
                cout << "WRONG" << endl;
            }
            return;
        }

        for (auto kek: preprocess) {
            pll u = {n, m};
            pll ur = {m, n};
            if (kek.first == u) {
                fori(i, n) {
                    fori(j, m) {
                        cout << kek.s[i][j] << " ";
                    }
                    cout << endl;
                }
                return;
            } else if (kek.first == ur) {
                fori(j, n) {
                    fori(i, m) {
                        cout << kek.s[i][j] << " ";
                    }
                    cout << endl;
                }
                return;
            }
        }

        if (!rec3(0, 0)) {
            cout << "fail" << endl;
            return;
        }
        fori(i, n) {
            fori(j, m) {
                cout << mtx[i][j] + 1 << " ";
            }
            cout << endl;
        }
        cout << endl;
        return;
    }
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    solve();
}