import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.StringTokenizer;

public class Main {
    public static class reader{
        BufferedReader bf;
        StringTokenizer st;

        reader() throws IOException {
            bf = new BufferedReader(new InputStreamReader(System.in));
            st = new StringTokenizer(bf.readLine());
        }

        String next() throws IOException {
            while(!st.hasMoreTokens()) st = new StringTokenizer(bf.readLine());
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] args) throws IOException {
	    reader in = new reader();
        PrintWriter out = new PrintWriter(System.out);
	    int t = in.nextInt();
	    BigInteger two = BigInteger.valueOf(2L);
        for (int i = 0; i < t; i++) {
            BigInteger n = new BigInteger(in.next());
            BigInteger m = new BigInteger(in.next());
            BigInteger nm = n.multiply(m);
            BigInteger all = BigInteger.ONE.add(nm).multiply(nm);

            BigInteger best = new BigInteger("99999999999999");

            int ans = 0;
            boolean hor = true;
            //hor
            int l = 1, r = n.intValue();

            while(l + 10 < r){
                int h1 = l + (r - l) / 3;
                BigInteger H = BigInteger.valueOf((long)h1);
                BigInteger Hm = H.multiply(m);
                BigInteger res1 = all.subtract(two.multiply(BigInteger.ONE.add(Hm).multiply(Hm))).abs();

                int h2 = l + (r - l) * 2 / 3;
                H = BigInteger.valueOf((long)h2);
                Hm = H.multiply(m);
                BigInteger res2 = all.subtract(two.multiply(BigInteger.ONE.add(Hm).multiply(Hm))).abs();

                int rval = res1.compareTo(res2);
                if(rval >= 0){
                    l = h1;
                }else {
                    r = h2;
                }
            }
            for(int h = l; h <= r; ++h){
                BigInteger H = BigInteger.valueOf((long)h);
                BigInteger Hm = H.multiply(m);
                BigInteger res = all.subtract(two.multiply(BigInteger.ONE.add(Hm).multiply(Hm))).abs();

                int rval = res.compareTo(best);
                if(rval < 0 || (rval == 0 && h < ans)){
                    best = res;
                    ans = h;
                }
            }

            //ver
            l = 1;
            r = m.intValue();

            while(l + 10 < r){
                int v1 = l + (r - l) / 3;
                BigInteger V = BigInteger.valueOf((long)v1);
                BigInteger res1 = all.subtract(two.multiply(V).multiply(n).multiply(nm.subtract(m).add(V).subtract(BigInteger.ONE))).abs();

                int v2 = l + (r - l) * 2 / 3;
                V = BigInteger.valueOf((long)v2);
                BigInteger res2 = all.subtract(two.multiply(V).multiply(n).multiply(nm.subtract(m).add(V).subtract(BigInteger.ONE))).abs();

                int rval = res1.compareTo(res2);
                if(rval >= 0){
                    l = v1;
                }else {
                    r = v2;
                }
            }
            for(int v = l; v <= r; ++v){
                BigInteger V = BigInteger.valueOf((long)v);
                //System.out.println(V.multiply(n).multiply(nm.subtract(m).add(V).subtract(BigInteger.ONE)));
                BigInteger res = all.subtract(two.multiply(V).multiply(n).multiply(nm.subtract(m).add(V).add(BigInteger.ONE))).abs();

                int rval = res.compareTo(best);
                if(rval < 0 || (rval == 0 && (hor || v < ans))){
                    hor = false;
                    best = res;
                    ans = v;
                }
            }

            if(hor){
                out.print("H ");
            }else out.print("V ");
            out.println(ans + 1);
        }

        out.close();
    }
}
