import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.StringTokenizer;

public class Main {
    public static class reader{
        BufferedReader bf;
        StringTokenizer st;

        reader() throws IOException {
            bf = new BufferedReader(new InputStreamReader(System.in));
            st = new StringTokenizer(bf.readLine());
        }

        String next() throws IOException {
            while(!st.hasMoreTokens()) st = new StringTokenizer(bf.readLine());
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }
    }

    static class Block{
        BigInteger numb;
        int len;
        char c;
        boolean zeros;

        Block(String s, char c){
            numb = new BigInteger(s);
            this.c = c;
        }

        public Block(BigInteger numb, int l, char c, boolean zs) {
            this.numb = numb;
            this.c = c;
            len = l;
            zeros = zs;
        }
    }

    static char[] g = {'A', 'G', 'T','C'};

    static Block[] v = new Block[100_000];
    static int vsize = 0;
    static PrintWriter out = new PrintWriter(System.out);

    public static void main(String[] args) throws IOException {
        reader in = new reader();
        String st = in.next();
        char[] s = st.toCharArray();
        int n = st.length();
        for(int i = 0; i < n; ++i) {
            BigInteger obr = BigInteger.ONE;
            int len = 0;
            boolean zeros = true;
            if (s[i] >= '0' && s[i] <= '9') {
                zeros = s[i] == '1';
                int j = i;
                for (; j < n; ++j) {
                    if (!(s[j] >= '0' && s[j] <= '9')) {
                        break;
                    }
                    if(j != i && s[j] != '0') zeros = false;
                }
                obr = new BigInteger(st.substring(i, j));
                len = j - i;
                i = j;
            }

            Block b = new Block(obr, len, s[i], zeros);
            v[vsize++] = b;
        }

        int best = 0;
        int type = 2;
        BigInteger x = BigInteger.ONE;
        BigInteger _2 = BigInteger.valueOf(2);
        char z = 'k';
        {
            BigInteger len = BigInteger.ONE;
            for (int i = 0; i < vsize; i++) {
                if (i > 0 && i < vsize - 1 && v[i].numb.equals(BigInteger.ONE) && v[i - 1].c == v[i + 1].c && (3 + v[i - 1].len + v[i + 1].len) - (Math.max(v[i - 1].len, v[i + 1].len) + 1 + 1) > best) {
                    int diff = (3 + v[i - 1].len + v[i + 1].len) - (v[i - 1].numb.add(BigInteger.ONE).add(v[i + 1].numb).toString().length() + 1);
                    if (diff > best) {
                        best = diff;
                        type = 2;
                        x = len;
                    }
                }
                if (best == 0 && (v[i].zeros || v[i].numb.compareTo(_2) <= 0)) {
                    best = 1;
                    type = 2;
                    x = len;
                }
                len = len.add(v[i].numb);
            }

            if (type == 2) {
                out.println("2 " + x);
            } else out.println("3 " + x + " " + z);
        }

        best = 1;
        type = 1;
        x = BigInteger.ZERO;
        z = (v[0].c == g[0] ? g[1]: g[0]);

        BigInteger len = BigInteger.ZERO;
        BigInteger three = BigInteger.valueOf(3);
        for (int i = 0; i < vsize; i++) {
            if(v[i].numb.compareTo(three) > 0){
                BigInteger kek = v[i].numb;
                int keklen = kek.toString().length();

                BigInteger fpart = BigInteger.TEN.pow(keklen - 1);
                int fpartlen = keklen;
                if(fpart.equals(BigInteger.ONE)){
                    fpart = fpart.add(BigInteger.ONE);
                }
                if(kek.subtract(fpart).toString().length() < fpartlen - 1){
                    --fpartlen;
                    fpart = fpart.divide(BigInteger.TEN);
                }
                kek = kek.subtract(fpart);

                int newlen = fpartlen;

                if(!kek.equals(BigInteger.ONE)) newlen += kek.toString().length();
                newlen += 3;

                int diff = newlen - (v[i].len + 1);

                if(diff > best){
                    best = diff;
                    type = 1;
                    x = len.add(fpart);
                    z = (v[i].c == 'A' ? 'C' : 'A');
                }
            }
            len = len.add(v[i].numb);
        }
        out.println("1 " + x + " " + z);
        out.close();
    }
}
