import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Random;
import java.util.StringTokenizer;

public class Main {
    public static class reader{
        BufferedReader bf;
        StringTokenizer st;

        reader() throws IOException {
            bf = new BufferedReader(new InputStreamReader(System.in));
            st = new StringTokenizer(bf.readLine());
        }

        String next() throws IOException {
            while(!st.hasMoreTokens()) st = new StringTokenizer(bf.readLine());
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }
    }

    static class Block{
        BigInteger numb;
        int len;
        char c;
        boolean zeros;

        Block(String s, char c){
            numb = new BigInteger(s);
            this.c = c;
        }

        public Block(BigInteger numb, int l, char c, boolean zs) {
            this.numb = numb;
            this.c = c;
            len = l;
            zeros = zs;
        }
    }

    static char[] g = {'A', 'G', 'T','C'};

    static Block[] v = new Block[100_000];
    static int vsize = 0;
    static PrintWriter out = new PrintWriter(System.out);

    static String rofl(String st){
        String ans = "";
        for (int i = 0; i < st.length(); i++) {
            int j = i;
            int len = 0;
            for(; j < st.length(); ++j){
                if(st.charAt(i) == st.charAt(j))++len;
                else break;
            }
            if(len > 1) ans += len;
            ans += st.charAt(i);
            i = j - 1;
        }
        return ans;
    }

    static int dumb(){
        StringBuilder kek = new StringBuilder();
        for (int i = 0; i < vsize; i++) {
            BigInteger e = BigInteger.ZERO;
            while(e.compareTo(v[i].numb) < 0){
                e = e.add(BigInteger.ONE);
                kek.append(v[i].c);
            }
        }

        int bst1 = kek.length();
        int x1 = 0;
        char ch1 = 0;
        for (int i = 0; i < kek.length(); i++) {
             String keks = kek.substring(0, i) + kek.substring(i + 1);
             keks = rofl(keks);

             if(keks.length() < bst1){
                 bst1 = keks.length();
                 x1 = i + 1;
             }
        }
        out.println("2 " + x1);

        int bst2 = 0;
        int x2 = 0;
        char ch2 = 0;
        for (int i = 0; i < kek.length(); i++) {
            for(char ch: g) {
                String keks = kek.substring(0, i) + ch + kek.substring(i);
                keks = rofl(keks);

                if(keks.length() > bst2){
                    bst2 = keks.length();
                    x2 = i;
                    ch2 = ch;
                }
            }
        }

        return x1 * 1000 + x2;
    }

    static class anse{
        BigInteger x1, x2;
        char ch;

        public anse(BigInteger x1, BigInteger x2, char ch) {
            this.x1 = x1;
            this.x2 = x2;
            this.ch = ch;
        }
    }

    static anse solve(){
        int best = 0;
        int type = 2;
        BigInteger x = BigInteger.ONE;
        BigInteger _2 = BigInteger.valueOf(2);
        char z = 'k';
        {
            BigInteger len = BigInteger.ONE;
            for (int i = 0; i < vsize; i++) {
                if (i > 0 && i < vsize - 1 && v[i].numb.equals(BigInteger.ONE) && v[i - 1].c == v[i + 1].c && (3 + v[i - 1].len + v[i + 1].len) - (Math.max(v[i - 1].len, v[i + 1].len) + 1 + 1) > best) {
                    int diff = (3 + v[i - 1].len + v[i + 1].len) - (v[i - 1].numb.add(BigInteger.ONE).add(v[i + 1].numb).toString().length() + 1);
                    if (diff > best) {
                        best = diff;
                        type = 2;
                        x = len;
                    }
                }
                if (best == 0 && (v[i].zeros || v[i].numb.compareTo(_2) <= 0)) {
                    best = 1;
                    type = 2;
                    x = len;
                }
                len = len.add(v[i].numb);
            }

            if (type == 2) {
                out.println("2 " + x);
            } else out.println("3 " + x + " " + z);
        }


        anse e = new anse(BigInteger.ONE, BigInteger.ONE, 'a');
        e.x1 = x;


        best = 1;
        type = 1;
        x = BigInteger.ZERO;
        z = (v[0].c == g[0] ? g[1]: g[0]);

        BigInteger len = BigInteger.ZERO;
        BigInteger three = BigInteger.valueOf(3);
        for (int i = 0; i < vsize; i++) {
            if(v[i].numb.compareTo(three) >= 0){
                BigInteger kek = v[i].numb;
                int keklen = kek.toString().length();

                BigInteger fpart = BigInteger.TEN.pow(keklen - 1);
                int fpartlen = keklen;
                if(fpart.equals(BigInteger.ONE)){
                    fpart = fpart.add(BigInteger.ONE);
                }
                if(kek.subtract(fpart).toString().length() < fpartlen - 1){
                    --fpartlen;
                    fpart = fpart.divide(BigInteger.TEN);
                }
                kek = kek.subtract(fpart);

                int newlen = fpartlen;

                if(!kek.equals(BigInteger.ONE)) newlen += kek.toString().length();
                newlen += 3;

                int diff = newlen - (v[i].len + 1);

                if(diff > best){
                    best = diff;
                    type = 1;
                    x = len.add(fpart);
                    z = (v[i].c == 'A' ? 'C' : 'A');
                }
            }
            len = len.add(v[i].numb);
        }

        e.x2 = x;
        e.ch = z;
        return e;
    }

    public static void main(String[] args) throws IOException {
        reader in = new reader();
        String st = in.next();
        //Random rand = new Random(100);
        /*for (int afj = 0; afj < 1000; afj++) {
            vsize = 0;
            int za = (int)(rand.nextDouble() * 5 + 1);
            String st = "";
            int prev = 0;
            for (int i = 0; i < za; i++) {
                st += (int)(rand.nextDouble() * 5 + 1);
                if(st.charAt(st.length() - 1) == '1') st = st.substring(0, st.length() - 1);
                int ci = 0;
                while(ci == prev){
                    ci = (int)(rand.nextDouble() * 4);
                    prev = ci;
                    break;
                }
                st += g[ci];
            }*/


            char[] s = st.toCharArray();
            int n = st.length();
            for (int i = 0; i < n; ++i) {
                BigInteger obr = BigInteger.ONE;
                int len = 0;
                boolean zeros = true;
                if (s[i] >= '0' && s[i] <= '9') {
                    zeros = s[i] == '1';
                    int j = i;
                    for (; j < n; ++j) {
                        if (!(s[j] >= '0' && s[j] <= '9')) {
                            break;
                        }
                        if (j != i && s[j] != '0') zeros = false;
                    }
                    obr = new BigInteger(st.substring(i, j));
                    len = j - i;
                    i = j;
                }

                Block b = new Block(obr, len, s[i], zeros);
                v[vsize++] = b;
            }

            anse e = solve();

            out.println("2 " + e.x1);
            out.println("1 " + e.x2 + " " + e.ch);
            out.close();

            /*
            if(dumb() != solve()){
                System.out.println(dumb());
                System.out.println(solve());

                dumb();
                solve();
            }
        }*/
    }
}
